Program Free;
Uses
  Objects, Drivers, Views, Menus, App, Dialogs,
  MsgBox, Free_Mod;

Type
  PMyMenuBar = ^TMyMenuBar;
  TMyMenuBar = Object(TMenuBar)
    Procedure HandleEvent(Var Event : TEvent); Virtual;
  End;

  TMyApp = object(TApplication)
    MyReDraw    : Boolean;
    OldName     : String;
    OldMenuItem : PMenuItem;
    Constructor Init;
    Procedure HandleEvent(Var Event: TEvent); Virtual;
    Procedure GetEvent(Var Event: TEvent); Virtual;
    Procedure InitMenuBar; Virtual;
    Procedure InitStatusLine; Virtual;
    Procedure Find_And_Substitute(Event : TEvent);
  End;

Var
  Flag         : Boolean;
  RememberWord : Word;

  Procedure TMyMenuBar.HandleEvent(Var Event : TEvent);
  Var A : Byte;
  Begin
    If (Flag = True) And
       ((Event.Command = cmReceivedFocus) Or (Event.Command = cmReleasedFocus)) Then
      Begin
        Flag:= False;
        RememberWord:=0;
      End;
    TMenuBar.HandleEvent(Event);
  End;

{******************************* TMyApp ************************************}
  Procedure TMyApp.Find_And_Substitute(Event : TEvent);

  Procedure Find_Item(SmallRusChar : Char; BigRusChar : Char ; EnglishChar : Char);
  Var
    MyPMenuItem : PMenuItem;
  Begin
    {஢ਬ,   㭪   ᮮ⢥饩 让 ᪮ 㪢 }
    MyPMenuItem:= MenuBar^.FindItem(BigRusChar);
    {᫨   ஢ਬ,   㭪   ᮮ⢥饩 쪮}
    {᪮ 㪢 }
    If (MyPMenuItem = Nil) Then MyPMenuItem:= MenuBar^.FindItem(SmallRusChar);
    If (MyPMenuItem <> Nil) Then
    { ⠪ 㢠 !!!}
      Begin
        OldName:= MyPMenuItem^.Name^; { 室 ப  㭪}
        MyPMenuItem^.Name^:= '~' + EnglishChar + '~';{}
        MyReDraw:= True;                         { 䫠}
        OldMenuItem := MyPMenuItem;              { 㪠⥫}
      End
      Else MyReDraw:= False;
  End;

  Begin
    Case Event.KeyCode Of
{   ⠡ ᮮ⢥⢨}
      kbAltQ : Find_Item('','','Q');
      kbAltW : Find_Item('','','W');
      kbAltE : Find_Item('','','E');
      kbAltR : Find_Item('','','R');
      kbAltT : Find_Item('','','T');
      kbAltY : Find_Item('','','Y');
      kbAltU : Find_Item('','','U');
      kbAltI : Find_Item('','','I');
      kbAltO : Find_Item('','','O');
      kbAltP : Find_Item('','','P');

      kbAltA : Find_Item('','','A');
      kbAltS : Find_Item('','','S');
      kbAltD : Find_Item('','','D');
      kbAltF : Find_Item('','','F');
      kbAltG : Find_Item('','','G');
      kbAltH : Find_Item('','','H');
      kbAltJ : Find_Item('','','J');
      kbAltK : Find_Item('','','K');
      kbAltL : Find_Item('','','L');

      kbAltZ : Find_Item('','','Z');
      kbAltX : Find_Item('','','X');
      kbAltC : Find_Item('','','C');
      kbAltV : Find_Item('','','V');
      kbAltB : Find_Item('','','B');
      kbAltN : Find_Item('','','N');
      kbAltM : Find_Item('','','M');
    End;
  End;



  Constructor TMyApp.Init;
  Var R : TRect;
    Begin
      {⠭ 砫 祭}
      MyReDraw:= False;
      Flag:= False;
      TApplication.Init;
    End;
{----------------------------------------------------------------------------}
  Procedure TMyApp.HandleEvent(var Event: TEvent);
  Procedure About;
  Begin
  End;
  begin
    TApplication.HandleEvent(Event);
    if Event.What = evCommand then
      begin
        case Event.Command of
          cmAbout            : About;
        Else Exit;
      End;
    ClearEvent(Event);
  end;
end;
{----------------------------------------------------------------------------}
  Procedure TMyApp.GetEvent(Var Event: TEvent);

  Var
    MyPMenuItem : PMenuItem;

  Const
    HelpInUse: Boolean = False;

  Procedure ConvertRusChar(Var MyWord : Word);
  {८ࠧ 쪨 ᪨ 㪢  訥  }
    Begin
      Case Lo(MyWord) Of
        $80..$8F :  MyWord:= MyWord + 32;
        $A0..$AF :  MyWord:= MyWord - 32;
        $90..$9F :  MyWord:= MyWord + 80;
        $E0..$EF :  MyWord:= MyWord - 80;
      End;
    End;

  Begin
    TApplication.GetEvent(Event);

    If (Flag = True) And (Event.What = 0) Then
      Begin
        {᫥ ࠡ  롮  ⨬   室 ﭨ}
        Flag:= False;
        ConvertRusChar(RememberWord);
        Event.What:= evKeyDown;
        Event.Command:= RememberWord;
        Event.KeyCode:= RememberWord;
        PutEvent(Event);
      End;

    If (MenuBar^.Current <> Nil) And (Event.What = evKeyDown) Then
      If (Chr(Lo(Event.KeyCode)) in [''..'',''..'']) Then
        Begin
          { , ᫨ ப  ⨢  㭪  ࠭ }
          {    ᪮ ॣ, .. ⠢        }
          {ணࠬ ॠ஢  ᪨ 㪢  롮  }
          Flag:= True;
          RememberWord:= Event.KeyCode;
        End;

    If ((PView(MenuBar) = Current) Or (MenuBar^.Current <> Nil)) And MyReDraw Then
      Begin
        { , ᫨ ப  ⨢  㭪  ࠭ }
        { १  ⢨  ⠭   室}
        If (OldMenuItem <> nil) Then OldMenuItem^.Name^:= OldName;
        MenuBar^.DrawView;
        MyReDraw:= False;
      End;
    {஢ਬ   ᮡ⨥ ᮡ⨥    樨 Alt+-}
    If (Event.What = evKeyDown) Then
      If (Lo(Event.KeyCode) = 0) Then Find_And_Substitute(Event);

  End;
{----------------------------------------------------------------------------}
procedure TMyApp.InitMenuBar;
var R: TRect;
begin
  GetExtent(R);
  R.B.Y := R.A.Y + 1;
  MenuBar := New(PMyMenuBar, Init(R, NewMenu(

    NewSubMenu(' ~~ ', hcNoContext, NewMenu(
      NewItem('~~', '', kbNoKey, cmAbout, hcNoContext,
      NewLine(
      NewItem('~~', '', kbNoKey, cmCalendar, hcNoContext,
      NewItem('~~', '', kbNoKey, cmCalculator, hcNoContext,
      nil))))),

    NewSubMenu(' ~~ ', hcNoContext, NewMenu(
      NewItem('~~', 'F3', kbF3, cmGetDisk, hcNoContext,
      NewItem('~~४਩', 'F4', kbF4, cmChangeDir, hcNoContext,
      NewLine(
      NewItem('~~室', 'Alt-X', kbAltX, cmQuit, hcNoContext,
      nil))))),

    NewSubMenu(' ~~ ', hcNoContext, NewMenu(
      NewItem('~~믨', 'Ctrl-F1', kbCtrlF1, cmAccountInPut, hcNoContext,
      NewItem('~~஫', 'Ctrl-F2', kbCtrlF2, cmAccountControl, hcNoContext,
      NewItem('~~⠭', 'Ctrl-F3', kbCtrlF3, cmAccountOptions, hcNoContext,
      nil)))),

    nil)))
  )));
end;
{----------------------------------------------------------------------------}
procedure TMyApp.InitStatusLine;
var R: TRect;
begin
  GetExtent(R);
  R.A.Y := R.B.Y - 1;
  StatusLine := New(PStatusLine, Init(R,
            NewStatusDef(0, 0,
             NewStatusKey('~F1~ ', kbF1, cmHelp,
             NewStatusKey('~F10~ ', kbF10, cmMenu,
             NewStatusKey('~Alt-F3~ ', kbAltF3, cmClose,
             Nil))),
            NewStatusDef(300, $FFFF,
             NewStatusKey('~F1~ ', kbF1, cmHelp,
             NewStatusKey('~Alt-F3~ ', kbAltF3, cmClose,
             Nil)),
            NewStatusDef(1, 99,
             NewStatusKey('~F1~ ', kbF1, cmHelp,
             NewStatusKey('', kbF10, cmMenu,
             Nil)),
            Nil))))
           );
end;
{----------------------------------------------------------------------------}


Var
  MyApp: TMyApp;

Begin
  MyApp.Init;
  MyApp.Run;
  MyApp.Done;
End.
{$A+,B+,D+,E-,F+,G+,I+,L-,N+,O-,R+,S+,V+,X+}
{$M 65520,0,655360}



